unit ClientModuleUnit1;

interface

uses
  System.SysUtils, System.Classes, ClientClassesUnit1, Datasnap.DSClientRest;

type
  TClientModule1 = class(TDataModule)
    DSRestConnection1: TDSRestConnection;
  private
    FInstanceOwner: Boolean;
    FAdventureMethodsClient: TAdventureMethodsClient;
    FID: string;
    function GetAdventureMethodsClient: TAdventureMethodsClient;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SendText(const AText: string; out AResponse: string; out AIsRunning: Boolean);
    procedure Start(out AResponse: string; out AIsRunning: Boolean);
    property InstanceOwner: Boolean read FInstanceOwner write FInstanceOwner;
    property AdventureMethodsClient: TAdventureMethodsClient read GetAdventureMethodsClient write FAdventureMethodsClient;
  end;

implementation

{%CLASSGROUP 'System.Classes.TPersistent'}

{$R *.dfm}

constructor TClientModule1.Create(AOwner: TComponent);
begin
  inherited;
  FInstanceOwner := True;
end;

destructor TClientModule1.Destroy;
begin
  FAdventureMethodsClient.Free;
  inherited;
end;

function TClientModule1.GetAdventureMethodsClient: TAdventureMethodsClient;
begin
  if FAdventureMethodsClient = nil then
    FAdventureMethodsClient:= TAdventureMethodsClient.Create(DSRestConnection1, FInstanceOwner);
  Result := FAdventureMethodsClient;
end;

procedure TClientModule1.SendText(const AText: string; out AResponse: string; out AIsRunning: Boolean);
begin
  AdventureMethodsClient.SendText(FID, AText, AResponse, AIsRunning);
end;

procedure TClientModule1.Start(out AResponse: string; out AIsRunning: Boolean);
begin
  AdventureMethodsClient.Start(FID, AResponse, AIsRunning);
end;

end.
