unit Common.Utilities;

interface

uses
  System.Classes;

procedure Postpone(SyncProc: TThreadProcedure; ADelayMS: Cardinal = 0);
procedure Async(AsyncProc, FinishedProc: TThreadProcedure);
function DelayProc(ADelayMS: Cardinal): TThreadProcedure;

implementation

uses
  System.Threading, System.SysUtils;

function DelayProc(ADelayMS: Cardinal): TThreadProcedure;
begin
  Result :=
    procedure
    begin
      if ADelayMS > 0 then begin
        Sleep(ADelayMS);
      end;
    end;
end;

procedure Async(AsyncProc, FinishedProc: TThreadProcedure);
begin
  TTask.Run(
    procedure
    begin
      if Assigned(AsyncProc) then
        AsyncProc();
      if Assigned(FinishedProc) then
        TThread.Queue(nil, FinishedProc);
    end);
end;

procedure Postpone(SyncProc: TThreadProcedure; ADelayMS: Cardinal = 0);
begin
  Async(DelayProc(ADelayMS), SyncProc);
end;

end.
