unit AdventureMethodsUnit;

interface

uses System.SysUtils, System.Classes, Datasnap.DSServer, Datasnap.DSAuth, DosAdventure;

type
{$METHODINFO ON}
  TAdventureMethods = class(TComponent)
  strict private
  private
  public
    function SendText(const ID, AText: string; out AResponse: string; out AIsRunning: Boolean): Boolean; overload;
    function Start(out ID, AResponse: string; out AIsRunning: Boolean): Boolean;
  end;
{$METHODINFO OFF}

implementation

{.$DEFINE USE_CODESITE}

uses
  {$IFDEF USE_CODESITE}CodeSiteLogging,{$ENDIF}
  System.StrUtils, AdventurePoolUnit;

function TAdventureMethods.SendText(const ID, AText: string; out AResponse: string; out AIsRunning: Boolean): Boolean;
begin
  {$IFDEF USE_CODESITE}CodeSite.TraceMethod(Self, 'SendText');{$ENDIF}

  result := TAdventurePool.SendText(ID, AText, AResponse, AIsRunning);
end;

function TAdventureMethods.Start(out ID, AResponse: string; out AIsRunning: Boolean): Boolean;
begin
  {$IFDEF USE_CODESITE}CodeSite.TraceMethod(Self, 'Start');{$ENDIF}

  Result := TAdventurePool.Start(ID, AResponse, AIsRunning);
end;

end.


